Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Friend Class Form1

    Inherits System.Windows.Forms.Form
    Private Sub txtScanChan_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtScanChan.TextChanged
        '11-13-00 new routine
        If txtScanChan.Text = "" Then GoTo EXIT1
        If (EditChan.Text = "0") Or (EditChan.Text = "1") Or (EditChan.Text = "6") Or (EditChan.Text = "7") Then
            M_203.scanChan = CShort(txtScanChan.Text)
            setPtr_()
        Else
            txtScanChan.Text = CStr(M_203.scanChan)
            getPtr_()
        End If
EXIT1:
    End Sub
    Private Sub btnStartScan_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnStartScan.Click
        '11-13-00 new routine
        Dim sRetVal As Short
        Dim iScanToken As Integer
        Dim iEdge As Integer
        Dim iScanVoltDispUdate As Short : iScanVoltDispUdate = 0
        iScanToken = &H8BS

        Frame1.Visible = True
        lblScanInf.Text = "S t a r t i n g   S c a n . . . . ."

        System.Windows.Forms.Application.DoEvents()

        If GetConversionInitialized = False Then
            'need to do some preliminary setup
            setPtr_()
            retVal = ClearVoltageArray
            getPtr_()
            setPtr_()
            retVal = GetVer
            getPtr_()
            setPtr_()
            retVal = GetCheckSum
            getPtr_()
            M_203.dac1volts = 1
            setPtr_()
            retVal = ChangeAnalogOutput(1) '10-15-12
            getPtr_()
            setPtr_()
            retVal = ClearVoltageArray
            getPtr_()
            lblScanInf.Text = "C A L I B R A T I N G . . . . ."
            System.Windows.Forms.Application.DoEvents()
            setPtr_()
            retVal = SysCal
            getPtr_()
            setPtr_()
            retVal = ClearVoltageArray
            getPtr_()
            setPtr_()
            retVal = GetConversion
            getPtr_()
            LabelConvWait.Visible = False
            GetConversionInitialized = True
        End If

        M_203.dataAcqMode = 0 '1 = polled  0 = scanning
        setPtr_()
        SetChanCode() 'set scanning channel
        getPtr_()
        setPtr_()
        sRetVal = ClearVoltageArray
        getPtr_()
        setPtr_()
        sRetVal = StartScanning(iScanToken, iEdge)
        getPtr_()
        Dim lNumScansInBuff As Integer
        If sRetVal Then
            MsgBox("There was an error starting the scan")
            GoTo EXIT1
        Else
            lblScanInf.Text = "S C A N     I N    P R O G R E S S . . . . ."
            System.Windows.Forms.Application.DoEvents()
            controlsDisable()
            btnEndScan.Enabled = True
            txtScanVoltage.Enabled = True
            btnStartScan.Enabled = False
            BtnSignOn.Enabled = False
            ThreadOrTimerStartStop.Enabled = False

            fScanning = 1
            M_203.dataAcqMode = 0 '1 = polled  0 = scanning
            setPtr_()
            While fScanning = 1
                Label6.Enabled = False
                txtScanChan.Enabled = False
                setPtr_()
                lNumScansInBuff = GetNumScansInBuffer()
                TextBox1.Text = lNumScansInBuff '10-19-12 temp
                getPtr_()

                If lNumScansInBuff > 0 Then
                    'txtNumScansInBuff.Text = lNumScansInBuff 'NOTE, the text box is hidden - expand the form to view it
                    System.Windows.Forms.Application.DoEvents()
                    setPtr_()
                    If GetOneScan Then GoTo WEND_ERR
                    TextBox2.Text = M_203.rawCount '10-19-12 temp
                    getPtr_()
                    setPtr_()
                    Gconv()
                    setPtr_()
                    Gconv()
                    getPtr_()
                    If M_203.scanInterval > 0.01 Then
                        frmat = VB6.Format((M_203.Voltage) / 1000.0#, "#.00000  ")
                        txtScanVoltage.Text = frmat
                    Else
                        'update box every 10th time during faster rates
                        iScanVoltDispUdate = iScanVoltDispUdate + 1
                        If iScanVoltDispUdate > 10 Then
                            iScanVoltDispUdate = 0
                            frmat = VB6.Format((M_203.Voltage) / 1000.0#, "#.00000  ")
                            txtScanVoltage.Text = frmat
                        End If
                    End If
                End If

                System.Windows.Forms.Application.DoEvents()
            End While

WEND_ERR:
            Label6.Enabled = True
            txtScanChan.Enabled = True

            lblScanInf.Text = "E n d i n g   S c a n . . . . ."
            System.Windows.Forms.Application.DoEvents()
            setPtr_()
            sRetVal = StopScanning
            getPtr_()
            If sRetVal <> 0 Then EditMsg.Text = EditMsg.Text & vbCrLf & "End-scan token not echoed" & vbCrLf
DONE_WEND:

        End If

        EditMsg.Text = EditMsg.Text & vbCrLf & "Scan stopped"
        M_203.dataAcqMode = 1 '1 = polled  0 = scanning
        btnEndScan.Enabled = False
        txtScanVoltage.Enabled = False
        btnStartScan.Enabled = True
        setPtr_()
        SetChanCode() 'reset the polled mode channel
        getPtr_()

EXIT1:
        Frame1.Visible = False
        BtnSignOn.Enabled = True
        controlsEnable()
        ThreadOrTimerStartStop.Enabled = True
    End Sub
    Private Sub btnEndScan_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnEndScan.Click
        fScanning = 0
    End Sub
    Private Sub BtnGetConversion_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnGetConversion.Click
        Dim x As Object
        BtnGetConversion.Enabled = False
        BtnSignOn.Enabled = False
        LabelConvWait.Visible = True
        System.Windows.Forms.Application.DoEvents()
        M_203.dataAcqMode = 1 '10-15-12
        If GetConversionInitialized = True Then
            GoTo POLLED
        End If
        EditVoltage.Text = "No Voltage"
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        setPtr_()
        retVal = GetVer
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "Version: " & M_203.version
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "Failed to get version number"
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = GetCheckSum
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "Checksum OK"
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "Failed to get initial Checksum"
            GoTo CONTROL_SET
        End If
        M_203.dac1volts = 1
        setPtr_()
        retVal = ChangeAnalogOutput(1)
        getPtr_()
        'UPGRADE_WARNING: Couldn't resolve default property of object x. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        x = M_203.dac1volts
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac1volts initialized"
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac1volts not initialized"
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = ChangeAnalogOutput(1)
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac2volts initialized"
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac2volts not initialized"
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        EditMsg.Text = EditMsg.Text & vbCrLf & "Calibrating - please wait ...."
        System.Windows.Forms.Application.DoEvents()
        setPtr_()
        retVal = SysCal
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "System calibrated"
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "System calibration failed"
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        setPtr_()
        retVal = GetConversion
        getPtr_()
        LabelConvWait.Visible = False
        BtnGetConversion.Enabled = True
        BtnSignOn.Enabled = True
        System.Windows.Forms.Application.DoEvents()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion succeeded"
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion failed"
            GoTo CONTROL_SET
        End If
        GetConversionInitialized = True

POLLED:

        M_203.dataAcqMode = 1 '10-15-12
        'Pntr_Pass.M_203.ChanChgFlg = 0 '10-15-12
        setPtr_()
        retVal = GetConversion
        getPtr_()
        LabelConvWait.Visible = False
        BtnGetConversion.Enabled = True
        BtnSignOn.Enabled = True
        System.Windows.Forms.Application.DoEvents()
        If retVal = 0 Then
            'use following if you want more messages
            'EditMsg = EditMsg.Text _
            ''    & vbCrLf _
            ''    & "conversion succeeded"
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion failed"
            GoTo CONTROL_SET
        End If
        '11-13-00 frmat = Format$(M_203.Voltage, "#####.0000  ")
        frmat = VB6.Format((M_203.Voltage) / 1000.0#, "#.00000  ")
        EditVoltage.Text = frmat
        GoTo EXIT1

CONTROL_SET:
        BtnGetConversion.Enabled = False
        EditVoltage.Enabled = False
        BtnSignOn.Enabled = True
        GetConversionInitialized = False
        BtnCOM.Enabled = False
        EditCOM.Enabled = False
        BtnDigOut.Enabled = True
        EditDigOut.Enabled = True
        BtnDigIn.Enabled = True
        EditDigIn.Enabled = True
        EditChan.Enabled = False
        BtnChan.Enabled = False
        BtnAnalogOut.Enabled = False
        CheckDbgFile.Enabled = True
        EditAnalogOut.Enabled = False

        '11-13-00
        btnStartScan.Enabled = True
        txtScanChan.Enabled = True

EXIT1:
    End Sub
    Private Sub BtnSignOn_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnSignOn.Click
        With M_203
            '.comPort = objACB.COMPort - 1    '  COM port number (zero origin)
            '.comPort = objACB.COMPort - 1    '  COM port number (zero origin)
            .scanInterval = 0.1              '  will be adjusted at download time
            .numChannels = 1                 '  always just one channel
            .tScan = 1                       '  1 = normal scan
            .scanChan = 0                    '  always scanning channel A
            .pollChan = 0                    '  always polling channel A
            .subSample = 160                 '  60 Hz Value
            .wordCnt = 3            '  3 = 24-bit mode  (sample rate may force 2 = 16-bit mode)
            .bU = 1             '  always bipolar
            .gain = 1           '  always 1=5V
            .totalPeriods = 2       '  2 for 60 HZ Sample Rate (with 120 maxRate)
            .modeRegMid = 128       '  MSB=1 for 24 bit word length
            .modeRegLo = 2
            .baud = 0           '  0 = 9600 baud
            .timeBase = 256 - .subSample
            .runningAvg = 1
            .dataAcqMode = 0        '  0 = scanning (for SignOn call only -- polling OK)
            .inputBuffer = 32767        '  receive buffer size
            .wL = 128           '  word length -- 128 for 24-bit
        End With

        '11-9-00
        fScanning = 0


        LabelWait.Visible = True
        EditMsg.Text = "Signing on ..."
        BtnSignOn.Enabled = False
        System.Windows.Forms.Application.DoEvents()

        setPtr_()
        EchoTestFlg = 0
        retVal = SignOn(EchoTestFlg, 0)           '  restored by TP
        'retVal = 0 '10-15-12                     '  removed by TP

        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "Initial SignOn call succeeded"
            controlsEnable()
            ThreadOrTimerStartStop.Enabled = True
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "Initial SignOn call failed"
            MsgDisplay(("Sign-On error" & Chr(10) & "Change settings and try again"))
            BtnSignOn.Enabled = True
            System.Windows.Forms.Application.DoEvents()
            controlsDisable()
            ThreadOrTimerStartStop.Enabled = False
            Exit Sub                            '  added by TP
        End If
        'Dim bc As Double                      '  removed by TP
        'bc = M_203.gain

        LabelWait.Text = "Signed on"
        LabelWait.ForeColor = System.Drawing.ColorTranslator.FromOle(&HFF0000)

        '10-15-12 note Tarik: use either of the functions below. One creates a timer and continuously
        ' calls the signon and then gets a conversion and the other does the same with a thread. When 
        ' using either one, press the "stop thread/timer" to stop them
        Exit Sub


        Timer1.Enabled = True
        Exit Sub

        threadRun = True '10-15-12
        theThread = New Threading.Thread(AddressOf myThread)
        theThread.Start()
        ThreadOrTimerStartStop.Enabled = True
EXIT1:
    End Sub
    'UPGRADE_WARNING: Event CheckDbgFile.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub CheckDbgFile_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckDbgFile.CheckStateChanged
        If CheckDbgFile.CheckState = System.Windows.Forms.CheckState.Checked Then
            '11-9-00 fDebugFile = 1
            fDebugFile = 2
        Else
            fDebugFile = 0
        End If
    End Sub
    'UPGRADE_WARNING: Event EditCOM.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub EditCOM_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles EditCOM.TextChanged
        'do valid COM port check here
    End Sub
    Private Sub BtnCOM_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnCOM.Click
        'M_203.comPort = CDbl(EditCOM.Text) - 1
        M_203.comPort = CDbl(EditCOM.Text) - 1
        EditMsg.Text = EditMsg.Text & vbCrLf & "COM port changed"
    End Sub
    'UPGRADE_WARNING: Event EditChan.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub EditChan_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles EditChan.TextChanged

        'Debug.Print  'blank line
        Debug.Print("Testing Procs:") 'prints in immediate window

        'EditMsg = EditMsg.Text _
        ''    & vbCrLf & "fInvalidChanChange: " & fInvalidChanChange
        If fInvalidChanChange = True Then
            fInvalidChanChange = False
            GoTo EXIT1
        End If
        'EditMsg = EditMsg.Text _
        ''    & vbCrLf & EditChan
        If CDbl(EditChan.Text) = 0 Then GoTo ValidChan
        If CDbl(EditChan.Text) = 1 Then GoTo ValidChan
        If CDbl(EditChan.Text) = 6 Then GoTo ValidChan
        If CDbl(EditChan.Text) = 7 Then GoTo ValidChan
        'DoEvents
        EditMsg.Text = EditMsg.Text & vbCrLf & "invalid channel entry"
        fInvalidChanChange = True
        EditChan.Text = "" 'M_203.pollChan
        BtnChan.BackColor = System.Drawing.SystemColors.Control
        BtnChan.Text = "Chan."
        GoTo EXIT1
ValidChan:
        If fSignedOn = True Then
            BtnChan.Text = "Send"
            BtnChan.BackColor = System.Drawing.ColorTranslator.FromOle(&HFF)
        End If
EXIT1:
    End Sub
    Private Sub BtnChan_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnChan.Click
        If EditChan.Text = "" Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "No channel entered!!"
            GoTo EXIT1
        End If

        M_203.pollChan = CShort(EditChan.Text)
        M_203.ChanChgFlg = 1
        setPtr_()
        SetChanCode()
        getPtr_()
        BtnChan.BackColor = System.Drawing.SystemColors.Control
        BtnChan.Text = "Chan."
        EditMsg.Text = EditMsg.Text & vbCrLf & "channel changed"
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
EXIT1:
    End Sub
    'UPGRADE_WARNING: Event EditDigOut.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub EditDigOut_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles EditDigOut.TextChanged
        If CDbl(EditDigOut.Text) > 255 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "invalid digital output entry"
            EditDigOut.Text = CStr(M_203.digOutWord)
            BtnDigOut.Text = "Dig. Out"
            BtnDigOut.BackColor = System.Drawing.SystemColors.Control
        Else
            If fSignedOn = True Then
                BtnDigOut.Text = "Send"
                BtnDigOut.BackColor = System.Drawing.ColorTranslator.FromOle(&HFF)
            End If
        End If

    End Sub
    Private Sub BtnDigOut_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnDigOut.Click
        M_203.digOutWord = CInt(EditDigOut.Text)
        setPtr_()
        SetDigOut()
        If fSignedOn = True Then
            BtnDigOut.Text = "Dig. Out"
            BtnDigOut.BackColor = System.Drawing.SystemColors.Control
        End If
        EditMsg.Text = EditMsg.Text & vbCrLf & "Digital output changed"
    End Sub
    Private Sub BtnDigIn_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnDigIn.Click
        setPtr_()
        retVal = GetDigIn(DigInToken)
        getPtr_()
        If retVal <> 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "Digital input failed! Err: " & retVal
        Else
            EditDigIn.Text = CStr(M_203.lastDigInp)
            EditMsg.Text = EditMsg.Text & vbCrLf & "Digital input read"
        End If
    End Sub
    'UPGRADE_WARNING: Event CheckDAC1.CheckedChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub CheckDAC1_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckDAC1.CheckedChanged
        If eventSender.Checked Then
            DacToSet = 1
        End If
    End Sub
    'UPGRADE_WARNING: Event CheckDAC2.CheckedChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub CheckDAC2_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckDAC2.CheckedChanged
        If eventSender.Checked Then
            DacToSet = 2
        End If
    End Sub
    'UPGRADE_WARNING: Event EditAnalogOut.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub EditAnalogOut_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles EditAnalogOut.TextChanged
        If CDbl(EditAnalogOut.Text) > 5 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "invalid analog output entry"
            EditAnalogOut.Text = CStr(M_203.dac1volts)
            BtnAnalogOut.Text = "Analog Out"
            BtnAnalogOut.BackColor = System.Drawing.SystemColors.Control
            GoTo EXIT1
        Else
            If fSignedOn = True Then
                BtnAnalogOut.Text = "Send"
                BtnAnalogOut.BackColor = System.Drawing.ColorTranslator.FromOle(&HFF)
                If CheckDAC1.Checked = True Then
                    M_203.dac1volts = CSng(EditAnalogOut.Text)
                Else
                    M_203.dac2volts = CSng(EditAnalogOut.Text)
                End If
            End If
        End If
EXIT1:
    End Sub
    Private Sub BtnAnalogOut_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles BtnAnalogOut.Click
        setPtr_()
        retVal = ChangeAnalogOutput(DacToSet)
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "DAC change succeeded"
            BtnAnalogOut.Text = "Analog Out"
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "DAC change failed"
            BtnAnalogOut.Text = "NOT sent"
        End If
    End Sub
    Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        ReadCfgFile()

        With M_203
            '.comPort = objACB.COMPort - 1    '  COM port number (zero origin)
            '.comPort = objACB.COMPort - 1    '  COM port number (zero origin)
            .scanInterval = 0.1              '  will be adjusted at download time
            .numChannels = 1                 '  always just one channel
            .tScan = 1                       '  1 = normal scan
            .scanChan = 0                    '  always scanning channel A
            .pollChan = 0                    '  always polling channel A
            .subSample = 160                 '  60 Hz Value
            .wordCnt = 3            '  3 = 24-bit mode  (sample rate may force 2 = 16-bit mode)
            .bU = 1             '  always bipolar
            .gain = 1           '  always 1=5V
            .totalPeriods = 2       '  2 for 60 HZ Sample Rate (with 120 maxRate)
            .modeRegMid = 128       '  MSB=1 for 24 bit word length
            .modeRegLo = 2
            .baud = 0           '  0 = 9600 baud
            .timeBase = 256 - .subSample
            .runningAvg = 1
            .dataAcqMode = 0        '  0 = scanning (for SignOn call only -- polling OK)
            .inputBuffer = 32767        '  receive buffer size
            .wL = 128           '  word length -- 128 for 24-bit
        End With

        txtScanChan.Text = CStr(M_203.scanChan)
        EditCOM.Text = CStr(M_203.comPort + 1)
        EditChan.Text = CStr(M_203.pollChan)
        EditDigOut.Text = CStr(M_203.digOutWord)
        EditDigIn.Text = CStr(M_203.lastDigInp)
        DigInToken = &H80S '80 = Get digital input, 8E = Get digital input with checksum
        M_203.dataAcqMode = 1 '1 = polled  0 = scanning
        M_203.wordCnt = 3 'always 24-bit
        fSignedOn = False
        CheckDAC1.Checked = True
        fDebugFile = False
        fInvalidChanChange = False

        threadRun = False '10-15-12
        curChan = 7 '10-15-12
    End Sub
    Sub myThread()
        setPtr_()
        ''#############
        With M_203
            '.comPort = objACB.COMPort - 1    '  COM port number (zero origin)
            '.comPort = objACB.COMPort - 1    '  COM port number (zero origin)
            .scanInterval = 0.1              '  will be adjusted at download time
            .numChannels = 1                 '  always just one channel
            .tScan = 1                       '  1 = normal scan
            .scanChan = 0                    '  always scanning channel A
            .pollChan = 0                    '  always polling channel A
            .subSample = 160                 '  60 Hz Value
            .wordCnt = 3            '  3 = 24-bit mode  (sample rate may force 2 = 16-bit mode)
            .bU = 1             '  always bipolar
            .gain = 1           '  always 1=5V
            .totalPeriods = 2       '  2 for 60 HZ Sample Rate (with 120 maxRate)
            .modeRegMid = 128       '  MSB=1 for 24 bit word length
            .modeRegLo = 2
            .baud = 0           '  0 = 9600 baud
            .timeBase = 256 - .subSample
            .runningAvg = 1
            .dataAcqMode = 0        '  0 = scanning (for SignOn call only -- polling OK)
            .inputBuffer = 32767        '  receive buffer size
            .wL = 128           '  word length -- 128 for 24-bit
        End With
        ''###########

        Do While threadRun = True '10-15-12
            M_203.scanChan = 0                   '  always scanning channel A
            Dim nomRate As Single
            'Dim objEvent As CPAcqlog.CPAcqDevEvent
            Dim maxInterval, minInterval As Double '  dummies

            nomRate = 0.01 'sampRate              '  suggested sample rate
            If nomRate < 0.1 Then nomRate = 0.1 '		'  apply limits
            If nomRate > 50 Then nomRate = 50 '		'  DLL allows more, but is noisy

            M_203.modeRegLo = Int((120 / nomRate) + 0.5)     '  taken from DOS example code
            If M_203.modeRegLo = 0 Then M_203.modeRegLo = 1
            setPtr_()
            Call SendADMode()
            getPtr_()
            M_203.scanInterval = 1 / nomRate         '  suggested sample interval
            setPtr_()
            Call CheckScanTime(M_203.scanInterval, maxInterval, minInterval)
            setPtr_()
            If SignOn(0, 0) <> 0 Then   '  TOM:  THIS IS THE CALL THAT FAILS AND GENERATES THE ERROR IN THE SCTREEN DUMP
                MsgBox("Thread Signon call failed")
                Exit Do
            Else
                MsgBox("Thread Signon call succeeded")
            End If
            Sleep(500)
        Loop

        MsgBox("thread exiting")
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ThreadOrTimerStartStop.Click
        If (threadRun = True) Or (Timer1.Enabled = True) Then
            threadRun = False '10-15-12
            Timer1.Enabled = False '10-15-12
            MsgBox("thread or timer stopped")
            ThreadOrTimerStartStop.Text = "start thread/timer"
            controlsEnable()
        Else
            'threadRun = True '10-15-12
            Timer1.Enabled = True '10-15-12
            MsgBox("thread or timer started")
            ThreadOrTimerStartStop.Text = "stop thread/timer"
            controlsDisable()
        End If
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static EchoTestFlg As Short = 0
        Static callRetVal As Short = 0
        Static fDebug As Byte = 2

        Static tickCount As Short = 0

        tickCount += 1
        EditMsg.Text = EditMsg.Text & vbCrLf & "Entering timer: #" & CStr(tickCount)
        scrollText()
        Application.DoEvents()

        M_203.scanChan = 0                   '  always scanning channel A
        Dim nomRate As Single
        Dim maxInterval, minInterval As Double    '  dummies

        nomRate = 0.01 'sampRate                  '  suggested sample rate
        If nomRate < 0.1 Then nomRate = 0.1 '		'  apply limits
        If nomRate > 50 Then nomRate = 50 '		   '  DLL allows more, but is noisy

        M_203.modeRegLo = Int((120 / nomRate) + 0.5)     '  taken from DOS example code
        If M_203.modeRegLo = 0 Then M_203.modeRegLo = 1
        setPtr_()
        Call SendADMode()
        getPtr_()
        M_203.scanInterval = 1 / nomRate          '  suggested sample interval
        setPtr_()
        Call CheckScanTime(M_203.scanInterval, maxInterval, minInterval)
        getPtr_()
        If SignOn(0, 0) <> 0 Then   '  TOM:  THIS IS THE CALL THAT FAILS AND GENERATES THE ERROR IN THE SCTREEN DUMP
            EditMsg.Text = EditMsg.Text & vbCrLf & "Timer Signon call FAILED"
            '  next three lines added by TP
            EditMsg.Text = EditMsg.Text & vbCrLf & "Timer disabled"
            scrollText()
            Timer1.Enabled = False
        Else
            'EditMsg.Text = EditMsg.Text & vbCrLf & "Timer Signon call succeeded"
            EditMsg.Text = EditMsg.Text & vbCrLf & "Timer Signon call succeeded"
            Application.DoEvents()
            scrollText()
            ChanChangeFromTimer()         '  IF THIS IS COMMENTED OUT, THERE IS STILL TROUBLE
            justGetConversion()           '  IF THIS IS COMMENTED OUT, THERE IS NO TROUBLE
        End If

        EditMsg.Text = EditMsg.Text & vbCrLf & "Exiting timer: #" & CStr(tickCount)
        scrollText()

    End Sub
    Sub scrollText()
        EditMsg.SelectionLength = 0
        EditMsg.SelectionStart = Len(EditMsg.Text)
        EditMsg.ScrollToCaret()
    End Sub
    Sub justGetConversion()
        Dim x As Object
        BtnGetConversion.Enabled = False
        BtnSignOn.Enabled = False
        LabelConvWait.Visible = True
        System.Windows.Forms.Application.DoEvents()

        M_203.dataAcqMode = 1 '10-15-12

        If GetConversionInitialized = True Then
            GoTo POLLED
        End If

        EditVoltage.Text = "No Voltage"
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        setPtr_()
        retVal = GetVer
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "Version: " & M_203.version
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "Failed to get version number"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        retVal = GetCheckSum
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "Checksum OK"
            scrollText()
            Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "Failed to get initial Checksum"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        M_203.dac1volts = 1
        setPtr_()
        retVal = ChangeAnalogOutput(1)
        getPtr_()
        'UPGRADE_WARNING: Couldn't resolve default property of object x. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        x = M_203.dac1volts
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac1volts initialized"
            scrollText()
            Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac1volts not initialized"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = ChangeAnalogOutput(1)
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac2volts initialized"
            scrollText()
            Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "M_203.dac2volts not initialized"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        EditMsg.Text = EditMsg.Text & vbCrLf & "Calibrating - please wait ...."
        System.Windows.Forms.Application.DoEvents()
        retVal = SysCal
        getPtr_()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "System calibrated"
            scrollText()
            Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "System calibration failed"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        setPtr_()
        retVal = GetConversion
        getPtr_()
        LabelConvWait.Visible = False
        BtnGetConversion.Enabled = True
        BtnSignOn.Enabled = True
        System.Windows.Forms.Application.DoEvents()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion succeeded"
            scrollText()
            Application.DoEvents()
            System.Windows.Forms.Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion failed"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        GetConversionInitialized = True

POLLED:

        M_203.dataAcqMode = 1 '10-15-12
        'Pntr_Pass.M_203.ChanChgFlg = 0 '10-15-12
        setPtr_()
        retVal = GetConversion
        getPtr_()
        LabelConvWait.Visible = False
        BtnGetConversion.Enabled = True
        BtnSignOn.Enabled = True
        System.Windows.Forms.Application.DoEvents()
        If retVal = 0 Then
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion succeeded"
            scrollText()
            Application.DoEvents()
        Else
            EditMsg.Text = EditMsg.Text & vbCrLf & "conversion failed"
            scrollText()
            Application.DoEvents()
            GoTo CONTROL_SET
        End If
        '11-13-00 frmat = Format$(M_203.Voltage, "#####.0000  ")
        frmat = VB6.Format((M_203.Voltage) / 1000.0#, "#.00000  ")
        EditVoltage.Text = frmat
        GoTo EXIT1

CONTROL_SET:
        BtnGetConversion.Enabled = False
        EditVoltage.Enabled = False
        BtnSignOn.Enabled = True
        GetConversionInitialized = False
        BtnCOM.Enabled = False
        EditCOM.Enabled = False
        BtnDigOut.Enabled = True
        EditDigOut.Enabled = True
        BtnDigIn.Enabled = True
        EditDigIn.Enabled = True
        EditChan.Enabled = False
        BtnChan.Enabled = False
        BtnAnalogOut.Enabled = False
        CheckDbgFile.Enabled = True
        EditAnalogOut.Enabled = False

        '11-13-00
        btnStartScan.Enabled = True
        txtScanChan.Enabled = True

EXIT1:
    End Sub
    Private Sub ChanChangeFromTimer()
        If curChan = 6 Then
            curChan = 0
        Else
            curChan = 6
        End If

        M_203.pollChan = CShort(curChan)
        M_203.ChanChgFlg = 1
        setPtr_()
        SetChanCode()
        getPtr_()
        BtnChan.BackColor = System.Drawing.SystemColors.Control
        EditChan.Text = curChan
        BtnChan.BackColor = System.Drawing.SystemColors.Control
        BtnChan.Text = "Chan."
        Application.DoEvents()
        'EditMsg.Text = EditMsg.Text & vbCrLf & "channel changed"
        'scrollText()
        setPtr_()
        retVal = ClearVoltageArray
        getPtr_()
        Sleep(50)
EXIT1:
    End Sub
    Sub setPtr_()
        Dim handle203Struct As GCHandle = GCHandle.Alloc(M_203, GCHandleType.Pinned)
        structPnt = handle203Struct.AddrOfPinnedObject()
        retVal = SetPtrs(structPnt, NewScanBuff(0), BuffDebugMsg(0))
        M_203 = CType(Marshal.PtrToStructure(structPnt, GetType(M203)), M203)
    End Sub
    Sub getPtr_()
        Dim myIntPtr As IntPtr
        myIntPtr = GetStructPtr()
        M_203 = CType(Marshal.PtrToStructure(myIntPtr, GetType(M203)), M203)
    End Sub
    Sub controlsEnable()
        BtnGetConversion.Enabled = True
        EditVoltage.Enabled = True
        BtnCOM.Enabled = True
        EditCOM.Enabled = True
        BtnDigOut.Enabled = True
        EditDigOut.Enabled = True
        BtnDigIn.Enabled = True
        EditDigIn.Enabled = True
        BtnSignOn.Enabled = True
        EditChan.Enabled = True
        BtnChan.Enabled = True
        BtnAnalogOut.Enabled = True
        EditAnalogOut.Enabled = True
        CheckDbgFile.Enabled = False
        fSignedOn = True
        btnStartScan.Enabled = True
        txtScanChan.Enabled = True
    End Sub
    Sub controlsDisable()
        BtnGetConversion.Enabled = False
        EditVoltage.Enabled = False
        BtnCOM.Enabled = False
        EditCOM.Enabled = False
        BtnDigOut.Enabled = False
        EditDigOut.Enabled = False
        BtnDigIn.Enabled = False
        EditDigIn.Enabled = False
        BtnSignOn.Enabled = False
        EditChan.Enabled = False
        BtnChan.Enabled = False
        BtnAnalogOut.Enabled = False
        EditAnalogOut.Enabled = False
        CheckDbgFile.Enabled = True
        fSignedOn = False
        btnStartScan.Enabled = False
        txtScanChan.Enabled = False
    End Sub

End Class